/*********************************************/
/*       File name:  goban.c                 */
/*    Project name:  socket/3moku            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/* ՃW[ */

#include "goban.h"

/******************/
/* J̕ϐQ */
/******************/

static char goban_my_stone;   /* ̐ */
static char goban_peer_stone; /* ̐ */

/* Ղ̒`Ə */
static char goban_plane[5][6] = { "+123+",
                                  "a...|",
                                  "b...|",
                                  "c...|",
                                  "+---+"};

static int goban_soc;         /* \Pbg̃fBXNv^ */

/********************/
/* J֐Q */
/********************/

/* Տ */
void goban_init(int soc, char my_stone, char peer_stone)
	/* soc        ʐMp\Pbg */
	/* my_stone   ̐       */
	/* peer_stone ̐       */
{
	/* ̃f[^͍Ō܂ŕێ */
	goban_soc=soc;
	goban_my_stone=my_stone;
	goban_peer_stone=peer_stone;
}

/* Ղ̕\ */
void goban_show()
{
	int i;
	for(i=0;i<5;i++) {
		printf("%s\n",goban_plane[i]);
	}
}

/* ̔Ԃ̏ */
int goban_peer_turn()
{
	char data[10]; /* Mobt@ */
	int x,y;       /* W */

	/* \Pbgǂ */
	read(goban_soc,data,10);

	/* 擪oCgďI */
	if ( data[0] == 'q' ) return -1;

	/* Wf[^̎o */
	y = (int)data[0] - (int)'a' + 1;
	x = (int)data[1] - (int)'0';

	/* f[^̍XV */
	goban_plane[y][x] = goban_peer_stone;

	return 1;
}

/* ̔Ԃ̏ */
int goban_my_turn()
{
	char data[10]; /* Mobt@ */
	int x,y;       /* W */

	/* L[{[h */
	while(1){
		fgets(data, 10, stdin);
		if( data[0] == 'q' )
			{ write(goban_soc,data,1); return -1; }
		if( data[0] < 'a' || data[0] > 'c' ||
		    data[1] < '1' || data[1] > '3' ) continue;
		break;
	}

	/* f[^̍XV */
	y = (int)data[0] - (int)'a' + 1;
	x = (int)data[1] - (int)'0';
	goban_plane[y][x] = goban_my_stone;

	/* M */
	write(goban_soc,data,10);

	return 1;
}

/* I */
void goban_destroy(){
	close(goban_soc);
}
