/*********************************************/
/*       File name:  service.c               */
/*    Project name:  socket/daemon           */
/*      Month/Year:  Feb/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/* T[rXW[ */

#include <fcntl.h>
#include "bb.h"

#define DATA_DIR "./data"
#define MENUSTRING "1.Ăяo  2.xu  3.T[N  4.s  9.I \n"


static int process(int soc, int item);

/* J֐ */
void service(int soc, char *myname)
	/* soc    \Pbg       */
	/* myname <-  argv[0]    */
{
	pid_t mypid;            /* PID        */
	char buf[BUF_LENGTH];   /* Mobt@   */
	int item;               /* j[ڔԍ */

	mypid=(int)getpid();
	sprintf(buf, "This is %s[%d] serving you.\n",
	        myname, (int)mypid);
	write(soc, buf, strlen(buf));

	do{
		write(soc, MENUSTRING, strlen(MENUSTRING)); /* j[M */
		read(soc, buf, 20);    /* ڑIM */
		sscanf(buf,"%d",&item);
	}
	while(process(soc, item));   /* ڏ */

	close(soc);
}

/* vCx[g֐ */
static int process(int soc, int item)
	/* soc   \Pbg         */
	/* item  j[ڔԍ */
{
	int  fd; /* f[^t@Ĉ߂̃t@CfBXNv^ */
	int  cnt;              /* t@C̓ǂݏooCg */
	char filename[FILENAME_LENGTH];      /* f[^t@C */
	char buf[BUF_LENGTH];                /* ړIobt@   */

	if(item==9)
		return 0;

	/* f[^t@C̓I */
	sprintf(filename, "%s/data%d", DATA_DIR, item);

	/* f[^t@C̃I[v */
	if((fd=open(filename, O_RDONLY))==-1){
		write(soc, "invalid number.\n", 17);
		return 1;
	}

	/* f[^t@C\Pbg֏o */
	while((cnt=read(fd, buf, BUF_LENGTH))!=0)
		write(soc, buf, cnt);

	/* f[^t@C̃N[Y */
	close(fd);
	return 1;
}
