/*********************************************/
/*       File name:  sessionman.c            */
/*    Project name:  socket/mtalk            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

/* ~jdqc̃ZbVǗvO */

#include <stdio.h>
#include <sys/types.h>

#define	MAX_ATTENDANTS 5
#define BUF_LEN	     80


static  char    buf[BUF_LEN];  /* Mobt@           */
static  fd_set  mask;	     /* selectp}XN     */
static  int     width;         /* ĎfBXNv^͈̔ */
static  int     attendants;    /* QҐl               */

/* QҊǗ̂߂̃f[^\ */
typedef	struct{
	int   fd;
	char  name[16];
} ATTENDANT;

static ATTENDANT p[MAX_ATTENDANTS]; /* Qҏ̔z */

/*  session ̃C[v̉[` */
static void send_all(int i, int n);
static void ending();

/*  enter  mserver_maccept() ɓnR[obN֐ */
void enter(int i, int fd)
	/* i   tԍ                 */
	/* fd  MɎgp\Pbg */
{
	int	len;   /* MoCg */
	static char *mesg1="Type your name.\n";
	static char *mesg2="Wait.\n";

	p[i].fd = fd;
	memset(p[i].name,0,16);
	write(fd, mesg1, strlen(mesg1));
	len = read(fd, p[i].name, 16);
	sprintf(p[i].name + len - 1, "  -->  ");
	write(fd, mesg2, strlen(mesg2));
}


/*  ZbV̏ */
void sessionman_init(int num, int maxfd)
	/* num    attendants ̐l    */
	/* maxfd  ő̃fBXNv^ */
{
	int i;                /* [vJE^ */
	static char *mesg="Communication Ready.\n";
	attendants = num;     /* QҐl̐ݒ */

	/* select ̂߂̃}XN  */
	width = maxfd + 1;
	FD_ZERO(&mask);
	FD_SET(0, &mask);
	for (i=0; i<num; i++){
		FD_SET(p[i].fd , &mask);
	}

	/* ZbVJñbZ[WSɑ */
	for (i=0; i<num; i++)
		write(p[i].fd, mesg, strlen(mesg));
}

/*  ZbṼC[v  */
void sessionman_loop()
{
	fd_set readOk;     /* select̂߂̃}XN */
	int i;             /* [vJE^       */

	while(1){
		/*  select ̑Oɖ readOk  */
		readOk = mask;
		select(width,(fd_set *)&readOk,NULL,NULL,NULL);

		/*  L[{[h̓͂肩H */
		if ( FD_ISSET(0, &readOk ) )
			ending();

		/* \Pbgɒׂ */
		for( i=0; i<attendants; i++){
			if(FD_ISSET(p[i].fd, &readOk)){
				int	n;

				n=read(p[i].fd,buf,BUF_LEN);
				send_all(i, n);
			}
		}
	}
}


/************************************/
/*  C[v̉[`B  */
/************************************/

/* I */
static void ending()
{
	int	i;

	for (i=0; i<attendants; i++)
		write(p[i].fd, "q", 1);
	for( i=0; i<attendants; i++)
		close(p[i].fd);
	exit(0);
}

static void send_all(int i, int n)
     /* i  p[i] ̖Ot */
     /* n  MoCg        */
{
	int  j;

	for(j=0; j<attendants; j++){
		write(p[j].fd, p[i].name, strlen(p[i].name));
		write(p[j].fd, buf, n);
	}
}
