/*********************************************/
/*       File name:  setup_server.c          */
/*    Project name:  socket/mylib            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include "mylib.h"

int setup_server(in_port_t port)
	/* ߂l   \Pbg̃fBXNv^ */
	/* port     ڑ̃|[gԍ       */
{
	struct sockaddr_in me; /* ̃\Pbg̃AhX */
	int soc_waiting;       /* ڑ҂̃\Pbg       */
	int soc;               /* ʐMɎg\Pbg       */

	/* ̃AhX sockaddr_in \̂ɐݒ */
	memset((char *)&me, 0, sizeof(me));
	me.sin_family = AF_INET;
	me.sin_addr.s_addr = htonl(INADDR_ANY);
	me.sin_port = htons(port);

	/* IPv4 ŃXg[^̃\Pbg̍쐬 */
	if ((soc_waiting = socket(AF_INET,SOCK_STREAM,0)) < 0 ){
		perror("socket");
		return -1;
	}

	/* \PbgɎ̃AhXݒ */
	if (bind(soc_waiting,(struct sockaddr *)&me,sizeof(me)) == -1){
		perror("bind");
		return -1;
	}

	/* \PbgŐڑ҂̐ݒ */
	listen(soc_waiting,1);
	fprintf(stderr,"successfully bound, now waiting.\n");

	/* ڑv܂ŃubN */
	soc = accept(soc_waiting, NULL, NULL);

	/* ڑ҂Ɏg\Pbg */
	close(soc_waiting);

	/* ʐMɎg\Pbg̃fBXNv^Ԃ */
	return soc;
}
