/*********************************************/
/*       File name:  setup_client.c          */
/*    Project name:  socket/mylib            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include "mylib.h"

int setup_client(char *hostname, in_port_t port)
	/* ߂l   \Pbg̃fBXNv^ */
	/* hostname ڑ̃zXg         */
	/* port     ڑ̃|[gԍ       */
{
	/* ϐ̐錾 */
	struct hostent *server_ent; /* ڑ̃zXg̏       */
	struct sockaddr_in server;  /* ڑ̃\Pbg̃AhX */
	int soc;                    /* ʐMɎg\Pbg         */

	/* ڑ̃zXgzXg̏𓾂 */
	if((server_ent = gethostbyname(hostname)) == NULL){
		perror("gethostbyname");
		return -1;
	}

	/* ڑ̃AhX sockaddr_in \̂ɐݒ */
	memset((char *)&server,0,sizeof(server));
	server.sin_family = AF_INET;
	server.sin_port = htons(port);
	memcpy((char *)&server.sin_addr, server_ent->h_addr,
	       server_ent->h_length);

	/* IPv4 ŃXg[^̃\Pbg쐬 */
	if ((soc = socket(AF_INET, SOCK_STREAM, 0)) < 0){
		perror("socket");
		return -1;
	}

	/* ڑ */
	if (connect(soc,(struct sockaddr *)&server,sizeof(server)) == -1){
		perror("connect");
		return -1;
	}
	fprintf(stderr, "connected.\n");

	/* \PbgԂ */
	return soc;
}
