/*********************************************/
/*       File name:  setup_client6.c         */
/*    Project name:  socket/mylib            */
/*      Month/Year:  Jan/2003                */
/*          Author:  Shuichi YUKITA          */
/*********************************************/

#include "mylib.h"

int setup_client(char *hostname, in_port_t port)
	/* ߂l   \Pbg̃fBXNv^ */
	/* hostname ڑ̃zXg         */
	/* port     ڑ̃|[gԍ       */
{
	struct addrinfo  hints; /* ڑ̕Iȏ       */
	struct addrinfo *res;   /* hintsɊÂʂ̊i[ꏊ   */
	int soc;                /* ʐMɎg\Pbg                 */
	char portstring[8];     /* {̓T[rX|[gԍ10i */

	/* ̃qg̐ݒ */
	sprintf(portstring, "%d", port);
	memset(&hints, 0, sizeof(struct addrinfo));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;

	/* ڑ̏ */
	if(getaddrinfo(hostname, portstring, &hints, &res) != 0){
		perror("getaddrinfo");
		return -1;
	}

	/* IPv4 ܂ IPv6 Ń\Pbg̍쐬 */
	if((soc = socket(res->ai_family,
	   res->ai_socktype, res->ai_protocol)) < 0){
		perror("socket");
		return -1;
	}

	/* ڑ */
	if(connect(soc,(struct sockaddr *)res->ai_addr,
	   res->ai_addrlen) == -1){
		perror("connect");
		return -1;
	}
	fprintf(stderr, "connected.\n");

	/* ŎgỈ */
	freeaddrinfo(res);

	/* \Pbg̃fBXNv^Ԃ */
	return soc;
}
